/**
 * 数组转双向链表
 * @param arr 数据源
 * @returns
 */
export function arrToDoubleLinkedList(arr) {
    if (!Array.isArray(arr) || arr.length === 0) {
        return { head: null, tail: null };
    }
    var head = null;
    var tail = null;
    arr.forEach(function (item) {
        var node = {
            val: item,
            next: null,
            prev: null,
        };
        if (head === null) {
            head = node;
            tail = node;
        }
        else {
            tail.next = node;
            node.prev = tail;
            tail = node;
        }
    });
    head.prev = tail;
    tail.next = head;
    return { head: head, tail: tail };
}
